;; if set to false, optimum models are not printed out
(set-option:produce-models true)

(declare-fun x1 () Int)
(declare-fun x2 () Int)
(declare-fun x3 () Int)
(declare-fun x4 () Int)
(declare-fun A () Bool)
(declare-fun B () Bool)

(assert (=> A (and (< (+ x1 x2 x3 x4) 30))))
(assert (=> B (and (< 120 (+ x1 x2 x3 x4)) (< (+ x1 x2 x3 x4) 200))))
(assert (< 0 x1))
(assert (< 0 x2))
(assert (< 0 x3))
(assert (< 0 x4))
(assert (or A B))

(push 1)
(minimize (+ x1 x2 x3 x4))
(check-sat)
(set-model -1)
(get-value (x1))
(get-value (x2))
(get-value (x3))
(get-value (x4))
(get-value (A))
(get-value (B))
(get-value (cost_0))
(pop 1)

(push 1)
(minimize (+ (- x1) (- x2) (- x3) (- x4)) )
(check-sat)
(set-model 0)
(get-value (x1))
(get-value (x2))
(get-value (x3))
(get-value (x4))
(get-value (A))
(get-value (B))
(get-value (cost_0))
(get-value (cost_1))
(pop 1)

; Minimization Works:
(minimize (+ x1 x2 x3 x4))
(minimize (+ (- x1) (- x2) (- x3) (- x4)) )
(check-sat)

(set-model 0)
(get-value (x1))
(get-value (x2))
(get-value (x3))
(get-value (x4))
(get-value (A))
(get-value (B))
(get-value (cost_0))
(get-value (cost_1))
(get-value (cost_2))
(get-value (cost_3))


(set-model 1)
(get-model)
